include 
{
   $"GUILib\gui.g"
   "expression.g"
}

global {
   str  gtstr = "\<calculator.gt>"
   uint dlg exprwnd
   arr  data of str
}

define
{
   IDC_ABOUTHEAD = 1003
   IDC_ABOUT     = 1005
   IDC_EXPR      = 1006
   IDC_VA        = 1007
   IDC_DRES      = 1014
   IDC_HRES      = 1015
   IDC_HELP      = 1016
   IDC_SAVE      = 1017
}

//-------------------------------------------------

func uint aboutproc( uint wnd id ctl codedlg )
{
   switch id
   {
      case 0
      {
         langsetwin( wnd )
         SetFocus( GetDlgItem( wnd, $IDOK ))
         dlgsubst( wnd )
         setdlgtext( wnd, $IDC_ABOUTHEAD, "aboutver".getlang())
      }
      case $IDOK,$IDCANCEL
      {
         EndDialog( wnd, 1 )
         return 1
      }
   }
   return 0
}

//-------------------------------------------------

func varset( uint num )
{
   str stemp

   getwintext( GetDlgItem( dlg, $IDC_VA + num ), stemp )
   if stemp.findch( '.', 0 ) < *stemp  
   {
      register[ num ].id = $NUM_DOUBLE
      register[ num ].dval = str2double( stemp )
   }
   else
   {
      register[ num ].id = $NUM_LONG
      register[ num ].lval = str2long( stemp )
   }
}

//-------------------------------------------------

func loadcur
{
   uint i
   uint cur = combo_getcurrent( exprwnd ) << 3  

   setwintext( exprwnd, data[ cur ] )
   fornum i = 0, 7
   {
      setwintext( GetDlgItem( dlg, $IDC_VA + i ), data[ cur + i + 1 ] )
      varset( i )
   }
}

//-------------------------------------------------

func varload
{
   gtitems gtis
   str     stemp
   uint    i  

   fornum i, *data >> 3
   {
      combo_add( exprwnd, data[ i << 3 ] )
   }
   combo_setcur( exprwnd, 0 )
   loadcur()    
}

//-------------------------------------------------

func gt2arr
{
   gtitems gtis
   str     stemp
   uint    i count

   foreach cur, gtapp.find("data").items( gtis )
   {
      count = *data
      data.expand( 8 )
      cur.get( data[ count ] )
      fornum i = 0, 7
      {
         cur.getattrib( "".appendch( 'A' + i ), data[ count + i + 1 ])
      }
   }
}

//-------------------------------------------------

func appendexpr( uint last )
{
   uint cur i 

   if last
   {
      cur = *data 
      data.expand( 8 )
   }
   getwintext( exprwnd, data[ cur ] )
   fornum i, 7
   {
      getwintext( GetDlgItem( dlg, $IDC_VA + i ), data[ cur + i + 1 ] )
   }
   combo_add( exprwnd, data[ cur ] )
}

//-------------------------------------------------

func saveexpr
{
   uint i k
   str  filename stemp = "<|data>\l"
   
   for  i, i < *data, i += 8
   {
      stemp += "<_ = \"\( data[i] )\""
      fornum k = 0, 7
      {
         stemp += " \("".appendch( 'A' + k ))=\( data[ i + k + 1 ])"      
      }
      stemp += ">\l"
   }
   stemp += "</data>"
   stemp.write( getmodulepath( filename, "calculator.dat"))
}

//-------------------------------------------------

func uint mainproc( uint wnd id ctl codedlg )
{
   subfunc calcexpr
   {
      lexem result   
      str   expr stemp
      uint  dres hres

      dres = GetDlgItem( wnd, $IDC_DRES ) 
      hres = GetDlgItem( wnd, $IDC_HRES ) 

      getwintext( exprwnd, expr )
      setwintext( dres, "" )
      setwintext( hres, "")
      switch ( calculate( expr, result ))
      {
         case $NUM_LONG
         {
            setwintext( dres, str( result.lval ))
            long2str( stemp, "%I64X", result.lval )     
            setwintext( hres, stemp )     
         } 
         case $NUM_DOUBLE : setwintext( dres, "\( result.dval )")         
      } 
   }
   switch id
   {
      case 0
      {
         langsetwin( wnd )
         dlgsubst( wnd )
         setwinicon( wnd, "appres/icon" )
         dlg = wnd
         exprwnd = GetDlgItem( dlg, $IDC_EXPR )
         varload()
         SetFocus( exprwnd )
      }
      case $IDC_EXPR
      {
         if codedlg == $CBN_EDITCHANGE : calcexpr()
         if codedlg == $CBN_SELCHANGE
         { 
            loadcur()
            calcexpr()
         }
      }
      case $IDC_ABOUT : showdialog( "appres/about" )
      case $IDC_SAVE : appendexpr( 1 )
      case $IDC_HELP : helpcontents() 
      case $IDCANCEL
      {
         appendexpr( 0 )
         saveexpr()
         EndDialog( wnd, 1 )
         return 1
      }
   }
   if id >= $IDC_VA && id < $IDC_VA + 7 && codedlg == $EN_CHANGE
   {
      varset( id - $IDC_VA )
      calcexpr()          
   }
   return 0
}

func main<main>
{
   str  data stemp

   gtapp += gtstr
   gtapp += data.read( getmodulepath( stemp, "calculator.dat"))
   helpfile( "calculator.chm" )
   gt2arr()

   gui_init()
   showdialog( "appres/main" )
   gui_deinit() 
}
